//
//
//  recode.pp - part of program UUECoder
//  Author : Andrew V. Sichevoi
//           2:6028/9@fidonet
//           sichevoi@mail.ru
//	     www.sichevoi.nm.ru
//
//  License: GNU GPL (v2.0 or high)
//
//


unit Recode;

 interface
 
uses
    DynArr; 
 
//=============================================================================
   
    { From FAQ RPC :) }
   {     Radix  }
   function FromDec(Num : LongInt; Radix : Byte) : String ; 
   {  Radix     }
   function ToDec  (Num : String ; Radix : Byte) : LongInt; 
   
   { 0xNNN -> NNN }
   function FromCF (Num : String) : String;
   
   { Recode }
   function RecodeChar(C     : Char;   InCP, OutCP : tWordDynArray) : Char;
   function RecodeStr (InStr : String; InCP, OutCP : tWordDynArray) : String;
   
   {P.S.  -   ;) }
   
//=============================================================================   


 implementation

 
//=============================================================================

const
     Digit : String[16] = '0123456789ABCDEF';

{=[ FromDec ]=================================================================}
function FromDec(Num : LongInt; Radix : Byte) : String;
var
   S : String;       
begin

 S:= '';
 repeat
  S  := Digit[(Num mod Radix) + 1] + S;
  Num:= Num div Radix;
 until (Num = 0);
 FromDec:= S;
 
end;
{=[ FromDec ]=================================================================}

{=[ ToDec ]===================================================================}
function ToDec(Num : String; Radix : Byte) : LongInt; 
var
    Res, Index : LongInt;
begin

 Res:= 0;
 while (Num[1] = '0') do Delete(Num, 1, 1);
 for Index:= 1 to Length(Num) do 
  Res:= (Res * Radix) + Pos(Num[Index], Digit) - 1;
 ToDec:= Res;
 
end; 
{=[ ToDec ]===================================================================}

{=[ FromCF ]==================================================================}
function FromCF(Num : String) : String;
begin

 if (Pos('0x', Num) = 1) then Delete(Num, 1, 2);
 FromCF:=  Num;
 
end; 
{=[ FromCF ]==================================================================}

{=[ RecodeChar ]==============================================================}
function RecodeChar(C : Char; InCP, OutCP : tWordDynArray) : Char;
var
   Index : Word;
begin

 RecodeChar:= C;
 for Index:=1 to InCP.Count do 
  if (C = Chr(InCP.At(Index))) then begin
   RecodeChar:= Chr(OutCP.At(Index));
   Break;
  end;
  
end;  
{=[ RecodeChar ]==============================================================}

{=[ RecodeStr ]===============================================================}
function RecodeStr(InStr : String; InCP, OutCP : tWordDynArray) : String;
var
    Index  : Word;
    OutStr : String;
begin

 OutStr:= '';
 for Index:=1 to Length(InStr) do
  OutStr:= OutStr + RecodeChar(InStr[Index], InCP, OutCP);
 RecodeStr:= OutStr;

end;
{=[ RecodeStr ]===============================================================}

//=============================================================================
end.